/*
** foreach.c for librevm in ERESI
**
** Implement the iteration on arrays and objects
**
** Started on Wed Feb 28 19:19:04 2007 mayhem
**
** $Id: foreach.c,v 1.2 2007/03/07 16:45:35 thor Exp $
**
*/
#include "revm.h"

/* Start an iteration */
int		cmd_foreach()
{
  revmobj_t	*var;
  u_char	flag;
  char		**keys;
  int		keynbr;
  hash_t	*table;
  int		index;
  void		*elem;
  int		infbound;
  int		upbound;

  PROFILER_IN(__FILE__, __FUNCTION__, __LINE__);
  
  /* Depends the mode we are in */
  flag = (world.curjob->curcmd->argc == 3   ? 1 : 
	  world.curjob->curcmd->use_regx[0] ? 2 : 3);

  /* Create or get the induction variable */
  var = vm_lookup_var(world.curjob->curcmd->param[0]);
  if (!var)
    {
      if (world.curjob->curcmd->curidx != REVM_IDX_UNINIT)
	PROFILER_ERR(__FILE__, __FUNCTION__, __LINE__,
		     "Unable to find induction variable", -1);
      var = vm_create_IMMED(ASPECT_TYPE_UNKNOW, 1, 0);
      hash_add(&vars_hash, strdup(world.curjob->curcmd->param[0] + 1), var);
    }

  /* Perform subcommand */
  switch (flag)
    {
      /* foreach elmvar of hashobj [as regx] */
    case 1:
    case 2:
      table = hash_find(world.curjob->curcmd->param[2]);
      if (!table)
	PROFILER_ERR(__FILE__, __FUNCTION__, __LINE__,
		     "Unable to find hash table", -1);
      keys = hash_get_keys(table, &keynbr);

      /* Use the correct index depending on the iteration */
    nextelem:
      if (world.curjob->curcmd->curidx == REVM_IDX_UNINIT)
	{
	  index = 0;
	  world.curjob->curcmd->curidx += 2;
	}
      else
	index = world.curjob->curcmd->curidx++;

      /* Bound check : go to the loop end when necessary */
      if (index >= keynbr)
	{
	  if (!world.curjob->curcmd->endlabel)
	    cmd_quit();
	  vm_move_pc(world.curjob->curcmd->endlabel);
	  PROFILER_ROUT(__FILE__, __FUNCTION__, __LINE__, 0);
	}

      /* Update of the induction variable */
      if (flag == 2 && regexec(&world.curjob->curcmd->regx[0], 
			       keys[index], 0, 0, 0))
	goto nextelem;
      elem = hash_get(table, keys[index]);
      if (var->type == ASPECT_TYPE_UNKNOW)
        vm_convert_object(var, table->type);
      if (var->type != table->type)
	PROFILER_ERR(__FILE__, __FUNCTION__, __LINE__,
		     "Invalid type for induction variable", -1);
      var->immed = 1;
      var->immed_val.ent = (elfsh_Addr) elem;
      break;
      
      /* foreach idxvar of minint until maxint */
    case 3:
      if (world.curjob->curcmd->curidx == REVM_IDX_UNINIT)
	{
	  infbound = vm_lookup_index(world.curjob->curcmd->param[2]);
	  world.curjob->curcmd->curidx = infbound + 1;
	}
      else
	infbound = world.curjob->curcmd->curidx++;
      upbound  = vm_lookup_index(world.curjob->curcmd->param[4]);

      /* Bound check */
      if (infbound >= upbound)
	{
	  if (!world.curjob->curcmd->endlabel)
	    cmd_quit();
	  vm_move_pc(world.curjob->curcmd->endlabel);
	  PROFILER_ROUT(__FILE__, __FUNCTION__, __LINE__, 0);
	}

      /* Set the induction variable */
      if (var->type == ASPECT_TYPE_UNKNOW)
        vm_convert_object(var, ASPECT_TYPE_INT);
      var->immed = 1;
      var->immed_val.word = infbound++;
      break;
    }

  /* Support when until goes decreasing */
  /* Here set the induction variable (3 cases : first, iterating, last) */

   PROFILER_ROUT(__FILE__, __FUNCTION__, __LINE__, 0);
 }


 /* End an iteration */
 int		cmd_forend()
 {
   PROFILER_IN(__FILE__, __FUNCTION__, __LINE__);
   vm_move_pc(world.curjob->curcmd->endlabel);
   PROFILER_ROUT(__FILE__, __FUNCTION__, __LINE__, 0);
}
