/*
** hammer.c for elfsh
**
** Contains libmjollnir commands bindings
**
** Last update December 10 2006 may
**
** $Id: hammer.c,v 1.3 2007/03/07 16:45:35 thor Exp $
**
*/
#include "revm.h"


/* To rebuild symtab use this command */
int	cmd_unstrip() 
{
  char logbuf[BUFSIZ];
  
  PROFILER_IN(__FILE__, __FUNCTION__, __LINE__);
  memset(logbuf,0x0,BUFSIZ);
  snprintf(logbuf, BUFSIZ - 1, " .: mjollnir : unstrip procedure started\n");
  vm_output(logbuf);
  if (!world.mjr_session.cur->analysed)
    cmd_analyse();
  memset(logbuf,0x0,BUFSIZ);
  snprintf(logbuf, BUFSIZ - 1, " .: mjollnir : unstrip procedure %s\n",
	   (mjr_symtab_rebuild(&world.mjr_session)) ? "completed successfully" : "faild");
  vm_output(logbuf);
 PROFILER_ROUT(__FILE__, __FUNCTION__, __LINE__, 0);
}


/* This command fill the blocks hash */
int	cmd_analyse() 
{
 char	logbuf[BUFSIZ];
 int	ret = 0;

 PROFILER_IN(__FILE__, __FUNCTION__, __LINE__);
 memset(logbuf,0x0,BUFSIZ);
 snprintf(logbuf, BUFSIZ - 1, " .: mjollnir : performing object analysis\n");
 vm_output(logbuf);
 memset(logbuf,0x0,BUFSIZ);
 ret = mjr_analyse(&world.mjr_session, 0);
 snprintf(logbuf, BUFSIZ - 1, " .: mjollnir : object analysis %s.\n",
	  (!ret ? "completed successfully" : "failed"));
 vm_output(logbuf);
 if (ret) 
   {
     memset(logbuf,0x0,BUFSIZ);
     snprintf(logbuf, BUFSIZ - 1, 
	      " .: mjollnir : calls seen: %d, recognized destination: %d\n",
	      world.mjr_session.cur->calls_seen,
	      world.mjr_session.cur->calls_found);
     vm_output(logbuf);
   }
 PROFILER_ROUT(__FILE__, __FUNCTION__, __LINE__, 0);
}



/* Shortcut command to rename symbols */
int	cmd_rename() 
{
 PROFILER_IN(__FILE__, __FUNCTION__, __LINE__);
 mjr_symbol_rename(&world.mjr_session,
		   world.curjob->curcmd->param[0],
		   world.curjob->curcmd->param[1]);
 PROFILER_ROUT(__FILE__, __FUNCTION__, __LINE__, 0);
}
