/*
** quit.c for elfsh
** 
** Started on  Sat Jan 25 11:19:53 2003 mayhem
** 
**
** $Id: print.c,v 1.5 2007/03/07 16:45:35 thor Exp $
**
*/
#include "revm.h"


/* Print an object */
void		vm_print_obj(revmobj_t *obj)
{
  char		byte;
  uint16_t	half;
  uint32_t	word;
  elfsh_Addr   	val;
  char		*str;
  char		logbuf[BUFSIZ];

  PROFILER_IN(__FILE__, __FUNCTION__, __LINE__);

  bzero(logbuf, BUFSIZ);
  switch (obj->type)
    {
    case ASPECT_TYPE_BYTE:
      byte = (obj->immed ? obj->immed_val.byte : obj->get_obj(obj->parent));
      snprintf(logbuf, BUFSIZ - 1, "%c (%hhd) ", byte, byte);
    case ASPECT_TYPE_SHORT:
      half = (obj->immed ? obj->immed_val.half : obj->get_obj(obj->parent));
      snprintf(logbuf, BUFSIZ - 1, "%04hx (%hd) ", half, half);
    case ASPECT_TYPE_LONG:
      val = (obj->immed ? obj->immed_val.ent : obj->get_obj(obj->parent));
      snprintf(logbuf, BUFSIZ - 1, XFMT " (" DFMT ") ", val, val);
    case ASPECT_TYPE_INT:
      word = (obj->immed ? obj->immed_val.word : obj->get_obj(obj->parent));
      snprintf(logbuf, BUFSIZ - 1, "%08X (%d) ", word, word);
      break;
    case ASPECT_TYPE_STR:
      str = (obj->immed ? obj->immed_val.str : 
	     obj->get_name(obj->root, obj->parent));
      snprintf(logbuf, BUFSIZ - 1, "%s ", str);
      break;
    default:
      snprintf(logbuf, BUFSIZ - 1, "UNKOBJ_TYPE_%u ", obj->type);
    }

  vm_output(logbuf);
  PROFILER_OUT(__FILE__, __FUNCTION__, __LINE__);
}



/* Print a string */
int			cmd_print()
{
  revmobj_t		*obj;
  volatile u_int	idx;
  char			logbuf[BUFSIZ];

  PROFILER_IN(__FILE__, __FUNCTION__, __LINE__);

  for (idx = 0; world.curjob->curcmd->param[idx] != NULL; idx++)
    {
      obj = vm_lookup_param(world.curjob->curcmd->param[idx]);
      if (!obj)
	{
	  snprintf(logbuf, BUFSIZ, "%s ", world.curjob->curcmd->param[idx]);
	  vm_output(logbuf);
	  continue;
	}
      vm_print_obj(obj);
    }

  vm_output("\n");
  if (!world.state.vm_quiet)
    vm_output("\n");
  PROFILER_ROUT(__FILE__, __FUNCTION__, __LINE__, 0);
}
