/*
** quit.c for elfsh
** 
** Started on  Sat Jan 25 11:19:53 2003 mayhem
**
** $Id: quit.c,v 1.6 2007/03/07 16:45:35 thor Exp $
**
*/
#include "revm.h"

u_char quit_msg_setup = 0;

void    vm_set_quit_msg(char *msg)
{
  strncpy(quit_msg, msg, sizeof(quit_msg) - 1);
  quit_msg_setup = 1;
}


/* Unload all the loaded object and exit the shell */
int		cmd_quit()
{
  elfshobj_t	*cur;
  int		index;
  char		logbuf[BUFSIZ];
  int		objnbr;
  char		**keys;
  char		**objkeys;
  int		keynbr;
  int		z;
  revmjob_t	*curjob;

  PROFILER_IN(__FILE__, __FUNCTION__, __LINE__);

  /* Do not unload files if we were sourcing a script */
  if (world.curjob->sourced == 0)
    {
      keys = hash_get_keys(&world.jobs, &keynbr);
      
      /* Unload every workspace */
      for (z = 0; z < keynbr; z++)
	{
	  curjob = hash_get(&world.jobs, keys[z]);
	  if (!vm_own_job(curjob))
	    continue;

	  snprintf(logbuf, BUFSIZ - 1, 
		   "\n [+] Unloading workspace : %u (%s) %c\n",
		   z, curjob->ws.name, (curjob->ws.active ? '*' : ' '));
	  vm_output(logbuf);

	  /* Unload all objects from this job */
	  objkeys = hash_get_keys(&curjob->loaded, &objnbr);
	  for (index = 0; index < objnbr; index++)
	    {
	      cur = hash_get(&curjob->loaded, objkeys[index]);
	      if (!world.state.vm_quiet)
		{
		  snprintf(logbuf, BUFSIZ - 1, 
			   " \t[*] Unloading object %u (%s) %c \n", 
			   index + 1, cur->name, 
			   (curjob->current == cur ? '*' : ' '));
		  vm_output(logbuf);
		}
	      elfsh_unload_obj(cur);
	    }
	}
    }

  /* The quit message */
  if (quit_msg_setup == 0)
    {
      snprintf(logbuf, BUFSIZ - 1, "\t .:: Bye -:: The %s %s \n",
	       vm_get_mode_name(), ELFSH_VERSION);
      vm_set_quit_msg(logbuf);
    }
  
  vm_output(quit_msg);
  
  /* Now the ugly code depending on the compilation options */
#if defined(ELFSHNET)
  if (world.curjob->ws.io.type == ELFSH_IONET &&
      vm_socket_del(inet_ntoa(world.curjob->ws.sock.addr.sin_addr)) < 0)
    fprintf(stderr, "error on quit from client on socket %d\n",
	    world.curjob->ws.sock.socket);
  else      
#endif
    { 
      vm_output_bcast("\n");
      if (world.curjob->sourced == 0)
	{
#if defined(USE_READLN)
	  readln_history_dump(world.state.vm_mode);
#endif
	  vm_exit(0);
	}
    }
  
  PROFILER_ROUT(__FILE__, __FUNCTION__, __LINE__, 0);
}
