/*
** utils.c for librevm in elfsh
**
** Started on  Fri Nov  2 15:21:56 2001 mayhem
** Updated on  Thu Jan 04 11:26:11 2007 mayhem
**
** $Id: utils.c,v 1.10 2007/03/07 16:45:35 thor Exp $
**
*/
#include "revm.h"


/* Useful when you have only one terminal */
int		cmd_meta()
{
  int		ret;

  PROFILER_IN(__FILE__, __FUNCTION__, __LINE__);

  if (!world.state.vm_quiet)
    vm_output(" [*] You are still in elfsh, exit bash "
	      "to get back to the regular prompt \n\n");

#if defined(USE_READLN)
  readln_terminal_unprepare(world.state.vm_mode);
#endif
  ret = vm_system(vm_lookup_string("$SHELL"));
#if defined(USE_READLN)
  readln_terminal_prepare(world.state.vm_mode);
#endif

  PROFILER_ROUT(__FILE__, __FUNCTION__, __LINE__, (ret));
}



/* Edit a file */
int             cmd_edit()
{
  int           ret;
  char		buff[BUFSIZ];

  PROFILER_IN(__FILE__, __FUNCTION__, __LINE__);

#if defined(USE_READLN)
  readln_terminal_unprepare(world.state.vm_mode);
#endif

  snprintf(buff, BUFSIZ, "%s %s",
	   vm_lookup_string("$EDITOR"),
	   world.curjob->curcmd->param[0]);

  ret = vm_system(buff);

#if defined(USE_READLN)
  readln_terminal_prepare(world.state.vm_mode);
#endif

  PROFILER_ROUT(__FILE__, __FUNCTION__, __LINE__, (ret));
}


/* Stop the scripting and pass in interactive mode */
int	cmd_stop()
{
  PROFILER_IN(__FILE__, __FUNCTION__, __LINE__);
  PROFILER_ROUT(__FILE__, __FUNCTION__, __LINE__, ELFSH_SCRIPT_STOP);
}


/* Precise a general weak bounded regex for all options */
int		cmd_alert()
{
  char		*str;
  char		logbuf[BUFSIZ];

  PROFILER_IN(__FILE__, __FUNCTION__, __LINE__);

  str = strdup(world.curjob->curcmd->param[0]);
 
  if (regcomp(&world.state.vm_alert, str, REG_EXTENDED) < 0)
    PROFILER_ERR(__FILE__, __FUNCTION__, __LINE__,
		      "Failed to compute regex", -1);
  world.state.vm_use_alert = 1;
  if (world.state.vm_salert)
    XFREE(__FILE__, __FUNCTION__, __LINE__,world.state.vm_salert);
  world.state.vm_salert = str;
  if (!world.state.vm_quiet)
    {
      snprintf(logbuf, BUFSIZ - 1, " [*] Changed alert regex to %s \n\n", str);
      vm_output(logbuf);
    }
  PROFILER_ROUT(__FILE__, __FUNCTION__, __LINE__, 0);
}


/* Get ASCII string for hash table */
char	*vm_ascii_type(hash_t *cur)
{
  return (aspect_typename_get(cur->type));
}


/* Get ASCII string for hash table */
char	*vm_ascii_vtype(vector_t *cur)
{
  return (aspect_typename_get(cur->type));
}
